#ifndef __BATCH_DIALOG_H
#define __BATCH_DIALOG_H

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _BatchDialog BatchDialog;

struct _BatchDialog {
	GtkWidget* self;

	GtkWidget* entry;
	GtkWidget* radio_button;
	GtkWidget* spin_from;
	GtkWidget* spin_to;
	GtkWidget* spin_width;
	GtkWidget* entry_a;
	GtkWidget* entry_z;
};

enum BATCH_MODE {
	BATCH_MODE_NONE,
	BATCH_MODE_CHAR,
	BATCH_MODE_NUM
};

void batch_dialog_init (BatchDialog* bd, GtkWindow* parent);
void batch_dialog_clear (BatchDialog* bd);
gint batch_dialog_run (BatchDialog* bd);

const gchar* batch_dialog_get_pattern (BatchDialog* bd);

gchar batch_dialog_get_char_min (BatchDialog* bd);
gchar batch_dialog_get_char_max (BatchDialog* bd);
gint  batch_dialog_get_int_min (BatchDialog* bd);
gint  batch_dialog_get_int_max (BatchDialog* bd);
gint  batch_dialog_get_int_width (BatchDialog* bd);


#ifdef __cplusplus
}
#endif

#endif  // End of __BATCH_DIALOG_H
