/*  category_setting.h
 *
 *
 *  2003  Plus Huang
 */

#ifndef __CATEGORY_SETTING_H
#define __CATEGORY_SETTING_H

#include "download_setting.h"

#ifdef __cplusplus
extern "C" {
#endif

#define CATEGORY_SETTING(o)   ((CategorySetting*)(o))
#define CATEGORY_SETTING_TAG  "category_setting"

typedef struct _CategorySetting   CategorySetting;

struct _CategorySetting {
	DownloadSetting download;

	char*        name;

	unsigned int state:4;         // category runtime state
	unsigned int multiple:1;      // if TRUE, name will be ignored

	unsigned int n_active_download;
	unsigned int completed_capacity;
	unsigned int recycled_capacity;

	// column visible
	unsigned int col_completed:1;
	unsigned int col_total:1;
	unsigned int col_speed:1;
	unsigned int col_retry:1;
	unsigned int col_url:1;
	// text area
	unsigned int text_filename:1;
	unsigned int text_directory:1;
	unsigned int text_url:1;
	unsigned int text_start_mode:1;
	unsigned int text_message:1;
};

enum CATEGORY_STATE {
	CATEGORY_STATE_WAITING   = DOWNLOAD_STATE_WAITING,
	CATEGORY_STATE_PAUSE     = DOWNLOAD_STATE_PAUSE,
	CATEGORY_STATE_EXECUTING = DOWNLOAD_STATE_EXECUTING,
	CATEGORY_STATE_COMPLETED = DOWNLOAD_STATE_COMPLETED,
	CATEGORY_STATE_RECYCLED  = DOWNLOAD_STATE_RECYCLED,
	CATEGORY_N_STATE         = DOWNLOAD_N_STATE
};

CategorySetting* category_setting_init (CategorySetting* cd);
void category_setting_destroy (CategorySetting* cd);
void category_setting_clear (CategorySetting* cd);
void category_setting_assign (CategorySetting* cd, CategorySetting* src);

#define category_setting_new ()    \
        category_setting_init (g_malloc (sizeof (CategorySetting)))

#define category_setting_set_name(cs, str)    setting_set_string (&(cs)->name, str)

void category_setting_write_xml (CategorySetting* setting,
                                 FILE* file, int level);

#ifdef __cplusplus
}
#endif

#endif  // End of __CATEGORY_SETTING_H
