#include "urlgfe.h"
#include "category_setting_view.h"

void category_setting_view_init (CategorySettingView *csv)
{
	GtkWidget* label;
	GtkWidget* hbox;
	GtkWidget* vbox;
	GtkWidget* vbox_frame;
	GtkWidget* frame;
	GtkSizeGroup* size_group;

	// initial base class : DownloadSettingView
	download_setting_view_init (DOWNLOAD_SETTING_VIEW (csv));
	download_setting_view_set_multiple (DOWNLOAD_SETTING_VIEW (csv),
	                                    TRUE);

	csv->multiple = FALSE;

	gtk_container_set_border_width (
	             (GtkContainer*)(DOWNLOAD_SETTING_VIEW(csv)->self), 5);
	csv->self = gtk_notebook_new ();
	vbox = gtk_vbox_new (FALSE, 5);

	size_group = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);

	hbox = gtk_hbox_new (FALSE, 5);
	csv->entry = gtk_entry_new ();
	csv->label_name = gtk_label_new_with_mnemonic (_("Category _name :"));
	gtk_label_set_mnemonic_widget (GTK_LABEL(csv->label_name),
	                               csv->entry);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    csv->label_name,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    csv->entry,
	                    TRUE, TRUE, 0);
	gtk_box_pack_start (GTK_BOX(vbox),
	                    hbox, FALSE, FALSE, 0);

	hbox = gtk_hbox_new (FALSE, 5);
	csv->spin_download = gtk_spin_button_new_with_range (1.0, 9.0, 1.0);
	label = gtk_label_new_with_mnemonic (_("Active _downloads :"));
	gtk_size_group_add_widget (size_group, label);
	gtk_label_set_mnemonic_widget (GTK_LABEL(label),
	                               csv->spin_download);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    label, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    csv->spin_download, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox),
	                    hbox, FALSE, FALSE, 0);
	gtk_entry_set_width_chars (GTK_ENTRY(csv->spin_download), 4);

	hbox = gtk_hbox_new (FALSE, 5);
	label = gtk_label_new (_(" Capacity of Completed : "));
	csv->spin_completed = gtk_spin_button_new_with_range (0.0, 9999.0, 1.0);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    label, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    csv->spin_completed, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox),
	                    hbox, FALSE, FALSE, 0);
	gtk_size_group_add_widget (size_group, label);
	gtk_entry_set_width_chars (GTK_ENTRY(csv->spin_completed), 4);

	hbox = gtk_hbox_new (FALSE, 5);
	label = gtk_label_new (_(" Capacity of Recycled : "));
	csv->spin_recycled = gtk_spin_button_new_with_range (0.0, 9999.0, 1.0);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    label, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox),
	                    csv->spin_recycled, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox),
	                    hbox, FALSE, FALSE, 0);
	gtk_size_group_add_widget (size_group, label);
	gtk_entry_set_width_chars (GTK_ENTRY(csv->spin_recycled), 4);

	// frame for column
	hbox = gtk_hbox_new (FALSE, 5);
	frame = gtk_frame_new (_("Visible columns :"));
	vbox_frame = gtk_vbox_new (FALSE, 5);
	gtk_container_set_border_width (GTK_CONTAINER(vbox_frame), 5);
	gtk_container_add (GTK_CONTAINER (frame), vbox_frame);
	csv->button_col_completed = gtk_check_button_new_with_label (_("Completed"));
	csv->button_col_total = gtk_check_button_new_with_label (_("Total"));
	csv->button_col_speed = gtk_check_button_new_with_label (_("Speed"));
	csv->button_col_retry = gtk_check_button_new_with_label (_("Retry"));
	csv->button_col_url = gtk_check_button_new_with_label (_("URL"));
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_col_completed,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_col_total,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_col_speed,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_col_retry,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_col_url,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox), frame, FALSE, FALSE, 0);

	// frame for TextView
	frame = gtk_frame_new (_("TextArea information :"));
	vbox_frame = gtk_vbox_new (FALSE, 5);
	gtk_container_set_border_width (GTK_CONTAINER(vbox_frame), 5);
	gtk_container_add (GTK_CONTAINER (frame), vbox_frame);
	csv->button_text_filename = gtk_check_button_new_with_label (_("Filename"));
	csv->button_text_directory = gtk_check_button_new_with_label (_("Directory"));
	csv->button_text_url = gtk_check_button_new_with_label (_("URL"));
	csv->button_text_message = gtk_check_button_new_with_label (_("Message"));
//	csv->button_col_url = gtk_check_button_new_with_label ("URL");
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_text_filename,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_text_directory,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_text_url,
	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox_frame),
	                    csv->button_text_message,
	                    FALSE, FALSE, 0);
//	gtk_box_pack_start (GTK_BOX(vbox_frame),
//	                    csv->button_col_url,
//	                    FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox), frame, FALSE, FALSE, 0);


	gtk_box_pack_start (GTK_BOX(vbox), hbox, FALSE, FALSE, 0);



	gtk_widget_show_all (vbox);

	label = gtk_label_new (_("Category Setting"));
	gtk_container_set_border_width (GTK_CONTAINER(vbox), 5);
	gtk_notebook_append_page (GTK_NOTEBOOK(csv->self),
	                          vbox, label);

	label = gtk_label_new (_("Download Default"));
	gtk_notebook_append_page (GTK_NOTEBOOK(csv->self),
	                          DOWNLOAD_SETTING_VIEW(csv)->self, label);
	gtk_widget_show (csv->self);
}

void category_setting_view_set (CategorySettingView* csv,
                                CategorySetting* setting)
{
	download_setting_view_set (DOWNLOAD_SETTING_VIEW (csv),
	                           DOWNLOAD_SETTING (setting));

	if ( csv->multiple == FALSE )
		gtk_entry_set_text (GTK_ENTRY(csv->entry), STR_N2E(setting->name));

	gtk_spin_button_set_value (GTK_SPIN_BUTTON(csv->spin_download),
	                           setting->n_active_download);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON(csv->spin_completed),
	                           setting->completed_capacity);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON(csv->spin_recycled),
	                           setting->recycled_capacity);

	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_col_completed),
	                              setting->col_completed);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_col_total),
	                              setting->col_total);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_col_speed),
	                              setting->col_speed);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_col_retry),
	                              setting->col_retry);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_col_url),
	                              setting->col_url);

	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_text_filename),
	                              setting->text_filename);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_text_directory),
	                              setting->text_directory);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_text_url),
	                              setting->text_url);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(csv->button_text_message),
	                              setting->text_message);
}

void category_setting_view_get (CategorySettingView* csv,
                                CategorySetting* setting)
{
	download_setting_view_get (DOWNLOAD_SETTING_VIEW (csv),
	                           DOWNLOAD_SETTING (setting));

	if ( csv->multiple == FALSE ) {
		category_setting_set_name (setting,
		                           gtk_entry_get_text (GTK_ENTRY(csv->entry)));
	}

	setting->n_active_download = gtk_spin_button_get_value_as_int (
	                                 GTK_SPIN_BUTTON(csv->spin_download));
	setting->completed_capacity = gtk_spin_button_get_value_as_int (
	                                  GTK_SPIN_BUTTON(csv->spin_completed));
	setting->recycled_capacity = gtk_spin_button_get_value_as_int (
	                                 GTK_SPIN_BUTTON(csv->spin_recycled));

	setting->col_completed = gtk_toggle_button_get_active (
	                             GTK_TOGGLE_BUTTON(csv->button_col_completed));
	setting->col_total = gtk_toggle_button_get_active (
	                         GTK_TOGGLE_BUTTON(csv->button_col_total));
	setting->col_speed = gtk_toggle_button_get_active (
	                         GTK_TOGGLE_BUTTON(csv->button_col_speed));
	setting->col_retry = gtk_toggle_button_get_active (
	                         GTK_TOGGLE_BUTTON(csv->button_col_retry));
	setting->col_url = gtk_toggle_button_get_active (
	                       GTK_TOGGLE_BUTTON(csv->button_col_url));

	setting->text_filename = gtk_toggle_button_get_active (
	                             GTK_TOGGLE_BUTTON(csv->button_text_filename));
	setting->text_directory = gtk_toggle_button_get_active (
	                              GTK_TOGGLE_BUTTON(csv->button_text_directory));
	setting->text_url = gtk_toggle_button_get_active (
	                        GTK_TOGGLE_BUTTON(csv->button_text_url));
	setting->text_message = gtk_toggle_button_get_active (
	                            GTK_TOGGLE_BUTTON(csv->button_text_message));
}

void category_setting_view_set_multiple (CategorySettingView *view,
                                         gboolean multiple)
{
	view->multiple = multiple;

	if ( multiple ) {
		gtk_widget_hide (view->entry);
		gtk_widget_hide (view->label_name);
		gtk_widget_set_sensitive (view->entry, FALSE);
		gtk_widget_set_sensitive (view->label_name, FALSE);
	}
	else {
		gtk_widget_show (view->entry);
		gtk_widget_show (view->label_name);
		gtk_widget_set_sensitive (view->entry, TRUE);
		gtk_widget_set_sensitive (view->label_name, TRUE);
	}
}

