#include "category_store.h"

void download_store_write_xml (DownloadStore* store,
                               FILE* file, int level)
{
	DownloadSetting* ds;
	GtkTreeIter iter;
	gboolean valid;

	download_store_lock (store);

	valid = gtk_tree_model_get_iter_first (GTK_TREE_MODEL (store->list_store),
	                                       &iter);
	while (valid) {
		gtk_tree_model_get (GTK_TREE_MODEL (store->list_store), &iter,
		                    DOWNLOAD_COL_DATA, &ds, -1);

		download_setting_write_xml (ds, file, level+1);

		valid = gtk_tree_model_iter_next (GTK_TREE_MODEL (store->list_store),
		                                  &iter);
	}

	download_store_unlock (store);
}

void category_write_xml (Category* category,
                         FILE* file, int level)
{

	if (level)
		fprintf (file, "%*c", level, ' ');
	fputs ("<" CATEGORY_TAG ">\n", file);

	category_setting_write_xml (CATEGORY_SETTING (category), file, level+1);

	// waiting store
	fprintf (file,
	         "%*c"
	         "<" CATEGORY_WAITING_STORE_TAG ">\n",
	         level+1, ' ');
	download_store_write_xml (&category->waiting_store, file, level+1);
	fprintf (file,
	         "%*c"
	         "</" CATEGORY_WAITING_STORE_TAG ">\n",
	         level+1, ' ');

	// completed store
	fprintf (file,
	         "%*c"
	         "<" CATEGORY_COMPLETED_STORE_TAG ">\n",
	         level+1, ' ');
	download_store_write_xml (&category->completed_store, file, level+1);
	fprintf (file,
	         "%*c"
	         "</" CATEGORY_COMPLETED_STORE_TAG ">\n",
	         level+1, ' ');

	// recycled store
	fprintf (file,
	         "%*c"
	         "<" CATEGORY_RECYCLED_STORE_TAG ">\n",
	         level+1, ' ');
	download_store_write_xml (&category->recycled_store, file, level+1);
	fprintf (file,
	         "%*c"
	         "</" CATEGORY_RECYCLED_STORE_TAG ">\n",
	         level+1, ' ');

	if (level)
		fprintf (file, "%*c", level, ' ');
	fputs ("</" CATEGORY_TAG ">\n", file);
}

void category_store_write_xml (CategoryStore* store,
                               FILE* file, int level)
{
	Category* cate;
	GtkTreeIter iter;
	gboolean valid;

	if (level)
		fprintf (file, "%*c", level, ' ');
	fputs ("<" CATEGORY_STORE_TAG ">\n", file);

	valid = gtk_tree_model_get_iter_first (GTK_TREE_MODEL (store->list_store),
	                                       &iter);

	while (valid) {
		gtk_tree_model_get (GTK_TREE_MODEL (store->list_store), &iter,
		                    CATEGORY_COL_DATA, &cate, -1);

		category_write_xml (cate, file, level+1);

		valid = gtk_tree_model_iter_next (GTK_TREE_MODEL (store->list_store),
		                                  &iter);
	}

	if (level)
		fprintf (file, "%*c", level, ' ');
	fputs ("</" CATEGORY_STORE_TAG ">\n", file);
}

