//  download_backend.h
//
//     define DownloadBackend interface
//
//
//  Plus Huang

#ifndef __DOWNLOAD_BACKEND_H
#define __DOWNLOAD_BACKEND_H

#include "download_thread.h"

#ifdef __cplusplus
extern "C" {
#endif

void download_backend_global_init ();
void download_backend_global_clean ();

gpointer download_backend_new (gpointer data);

void download_backend_destroy (gpointer backend);

gint download_backend_run     (gpointer backend, DownloadThread* dt);

enum DOWNLOAD_BACKEND_ERROR_CODE {
	DOWNLOAD_BACKEND_OK,
	DOWNLOAD_BACKEND_CAN_RETRY,
	DOWNLOAD_BACKEND_ABORT,
	DOWNLOAD_BACKEND_ERROR
};


#ifdef __cplusplus
}
#endif

#endif  // End of DOWNLOAD_BACKEND_H

