#ifndef __DOWNLOAD_DIALOG_H
#define __DOWNLOAD_DIALOG_H

#include "download_setting_view.h"
#include "category_view.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _DownloadDialog DownloadDialog;

struct _DownloadDialog {
	GtkDialog*            dialog;
	GtkWindow*            parent;
	GtkWidget*            hbox;
	DownloadSettingView   setting_view;

	gboolean              first_select;
	GtkTreeView*          category_view;
	CategoryStore*        category_store;
	Category*             selected_category;
};

#define download_dialog_new(parent)     \
        download_dialog_init (g_malloc (sizeof (DownloadDialog)), parent)

DownloadDialog* download_dialog_init (DownloadDialog* dd,
                                      GtkWindow* parent);

void download_dialog_clear (DownloadDialog* dd);
void download_dialog_destroy (DownloadDialog* dd);

gint download_dialog_run (DownloadDialog* dd);

void download_dialog_import_setting (DownloadDialog* dd,
                                     DownloadSetting* ds);

void download_dialog_export_setting (DownloadDialog* dd,
                                     DownloadSetting* ds);

void download_dialog_set_multiple (DownloadDialog* dd,
                                   gboolean multiple);

void download_dialog_set_global_setting (DownloadDialog* dd,
                                         GlobalSetting* gs);

// category selection
void download_dialog_set_category (DownloadDialog* dd,
                                   CategoryStore* store,
                                   Category* category);

void download_dialog_select_category (DownloadDialog* dd,
                                      CategoryStore* store,
                                      Category* category);


#ifdef __cplusplus
}
#endif

#endif  // End of __DOWNLOAD_DIALOG_H

