/*
	download_list_view.h

		View Widget for DownloadStore

	2003  Plus Huang
 */

#ifndef __DOWNLOAD_LIST_VIEW_H
#define __DOWNLOAD_LIST_VIEW_H

#include <gtk/gtk.h>
#include "download_store.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _DownloadListView DownloadListView;

struct _DownloadListView {
	GtkTreeView*       self;
	GtkScrolledWindow* container;

	DownloadStore*     store;
	// all columns in GtkTreeView
	GtkTreeViewColumn* col_name;
	GtkTreeViewColumn* col_completed;
	GtkTreeViewColumn* col_total;
	GtkTreeViewColumn* col_percent;
	GtkTreeViewColumn* col_speed;
	GtkTreeViewColumn* col_retry;
	GtkTreeViewColumn* col_url;
};

void download_list_view_init (DownloadListView* dlv,
                              DownloadStore* ds);
void download_list_view_clear (DownloadListView* dlv);

void download_list_view_hide_runtime_state (DownloadListView* dlv);

GList* download_list_view_selected_list_copy (DownloadListView* dlv, gint* n_selected);
void   download_list_view_selected_list_free (GList*);

#ifdef __cplusplus
}
#endif

#endif  // End of __DOWNLOAD_LIST_VIEW_H

