/*
	download_setting_view.h



	Object Hierarchy :

	SettingView
	|
	`--	ProxySettingView
	    |
	    `-- DownloadSettingView
	        |
	        `--CategorySettingView


 */

#ifndef __DOWNLOAD_SETTING_VIEW_H
#define __DOWNLOAD_SETTING_VIEW_H

#include <gtk/gtk.h>
#include "proxy_setting_view.h"

#ifdef __cplusplus
extern "C" {
#endif

#define DOWNLOAD_SETTING_VIEW(o)    ((DownloadSettingView*)(o))

typedef struct _DownloadSettingView DownloadSettingView;

struct _DownloadSettingView {
	ProxySettingView   proxy_setting_view;

	gboolean   multiple;

	// record filename when url changed
	// It will be free when receive "destroy" signal
	GString*   last_filename;

	GtkWidget* self;
	GtkWidget* button_folder;
	GtkWidget* combo_dir;
	GtkWidget* label_url;
	GtkWidget* label_filename;
	GtkWidget* label_referer;
	GtkWidget* entry_url;
	GtkWidget* entry_dir;
	GtkWidget* entry_filename;
	GtkWidget* entry_referer;
	GtkWidget* radio_auto;
	GtkWidget* radio_manual;
	GtkWidget* spin_parts;
	GtkWidget* spin_redirect;
	GtkWidget* spin_retries;
	GtkWidget* spin_delay;
};

enum DOWNLOAD_SETTING_VIEW_COMPLETE {
	DOWNLOAD_SETTING_COMPLETE,
	DOWNLOAD_SETTING_UNCOMPLETE,
	DOWNLOAD_SETTING_UNCOMPLETE_MULTIPlE,
	DOWNLOAD_SETTING_UNCOMPLETE_URL
};

void download_setting_view_init (DownloadSettingView* view);
void download_setting_view_set (DownloadSettingView* view,
                                DownloadSetting* setting);
void download_setting_view_get (DownloadSettingView* view,
                                DownloadSetting* setting);

gboolean download_setting_view_url_changed (DownloadSettingView* view);

// return : enum DOWNLOAD_SETTING_VIEW_COMPLETE
gint download_setting_view_check_field (DownloadSettingView* view);

void download_setting_view_set_history (DownloadSettingView* dsv,
                                        GList* directory_history);

void download_setting_view_set_multiple (DownloadSettingView *view,
                                         gboolean multiple);

#ifdef __cplusplus
}
#endif

#endif  /* End of __DOWNLOAD_SETTING_VIEW_H */

