#include "global_dialog.h"
#include "urlgfe.h"

GlobalDialog* global_dialog_new (GtkWindow* parent)
{
	GlobalDialog* gd = g_malloc (sizeof (GlobalDialog));
	GtkWidget* label;
	GtkWidget* hbox;
	GtkWidget* vbox;
	GtkWidget* vbox_dlg;

	gd->self = (GtkDialog*) gtk_dialog_new_with_buttons (_("Global Setting"),
                                                         parent,
	    (GTK_DIALOG_MODAL | GTK_DIALOG_NO_SEPARATOR | GTK_DIALOG_DESTROY_WITH_PARENT),
	                                                     GTK_STOCK_CANCEL,
	                                                     GTK_RESPONSE_CANCEL,
	                                                     GTK_STOCK_OK,
	                                                     GTK_RESPONSE_OK,
	                                                     NULL);
	gtk_window_set_default_size (GTK_WINDOW (gd->self), 250, 250);
	vbox_dlg = gd->self->vbox;
	vbox = gtk_vbox_new (FALSE, 5);
	hbox = gtk_hbox_new (FALSE, 5);

	label = gtk_label_new (_("Global"));
	gd->notebook = gtk_notebook_new ();
	gtk_box_pack_start (GTK_BOX (vbox_dlg), gd->notebook, TRUE, TRUE, 0);
	gtk_notebook_insert_page (GTK_NOTEBOOK(gd->notebook), vbox, label, 0);
	gtk_container_set_border_width (GTK_CONTAINER(vbox), 5);

	gd->spin_active_category = gtk_spin_button_new_with_range (1.0, 9.0, 1.0);
	label = gtk_label_new_with_mnemonic (_("Active _categories :"));
	gtk_label_set_mnemonic_widget (GTK_LABEL(label), gd->spin_active_category);
	gd->button_visible = gtk_check_button_new_with_mnemonic (_("Display category header"));

	gtk_box_pack_start (GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox), gd->button_visible, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(hbox), gd->spin_active_category, FALSE, FALSE, 0);

	label = gtk_label_new_with_mnemonic (_("_Monitor these file types in clipboard:"));
	gd->entry_extention = gtk_entry_new ();
	gd->button_monitoring = gtk_check_button_new_with_mnemonic (_("Monitoring clipboard"));
	gtk_box_pack_start (GTK_BOX(vbox), gtk_hseparator_new (), FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox), gd->button_monitoring, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox), label, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(vbox), gd->entry_extention, FALSE, FALSE, 0);

	gtk_widget_show_all (gd->notebook);

	return gd;
}

void global_dialog_destroy (GlobalDialog* gd)
{
	gtk_widget_destroy (GTK_WIDGET (gd->self));
	g_free (gd);
}

void global_dialog_set (GlobalDialog* gd, GlobalSetting* setting)
{
	gchar* ext_str;

	gtk_spin_button_set_value (GTK_SPIN_BUTTON(gd->spin_active_category),
	                           setting->n_active_category);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(gd->button_visible),
	                              setting->header_category_visible);

	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(gd->button_monitoring),
	                              setting->monitoring_clipboard);

	ext_str = global_setting_get_extention (setting);
	gtk_entry_set_text (GTK_ENTRY (gd->entry_extention), ext_str);
	g_free (ext_str);
}

void global_dialog_get (GlobalDialog* gd, GlobalSetting* setting)
{
	setting->n_active_category = gtk_spin_button_get_value_as_int (
	                                GTK_SPIN_BUTTON(gd->spin_active_category) );
	setting->header_category_visible = gtk_toggle_button_get_active (
	                                GTK_TOGGLE_BUTTON(gd->button_visible) );

	setting->monitoring_clipboard = gtk_toggle_button_get_active (
	                                GTK_TOGGLE_BUTTON(gd->button_monitoring) );
	global_setting_set_extention (setting,
	                     gtk_entry_get_text (GTK_ENTRY (gd->entry_extention)) );
}

