/*  global_setting.h
 *
 *
 *  2003  Plus Huang
 */

#ifndef __GLOBAL_SETTING_H
#define __GLOBAL_SETTING_H

#include <glib.h>
#include "category_setting.h"

#ifdef __cplusplus
extern "C" {
#endif

#define GLOBAL_SETTING(o)     ((GlobalSetting*)(o))
#define GLOBAL_SETTING_TAG    "global_setting"


typedef struct _GlobalSetting     GlobalSetting;

struct _GlobalSetting {
	CategorySetting category;

	unsigned int n_active_category;
	unsigned int header_category_visible:1;

	// directory history
	GList*       directory_list;
	unsigned int n_directory;

	// filename extention
	GList*       extention_list;
	gchar*       extention_data;
	gint         extention_size;
	gboolean     monitoring_clipboard;

	GStaticRecMutex  mutex;
};

GlobalSetting* global_setting_new ();
void global_setting_destroy (GlobalSetting* gs);

void global_setting_init (GlobalSetting* gs);
void global_setting_finalize (GlobalSetting* gs);
void global_setting_assign (GlobalSetting* gs, GlobalSetting* src);

void   global_setting_add_directory (GlobalSetting* gs,
                                     const gchar* directory);
GList* global_setting_get_directory_list (GlobalSetting* gs);

void   global_setting_set_extention (GlobalSetting* gs, const gchar* ext);
gchar* global_setting_get_extention (GlobalSetting* gs);
gboolean global_setting_find_extention (GlobalSetting* gs, const gchar* ext);

void global_setting_write_xml (GlobalSetting* setting,
                               FILE* file, int level);

#define global_setting_lock(g)   g_static_rec_mutex_lock (&(g)->mutex)
#define global_setting_unlock(g) g_static_rec_mutex_unlock (&(g)->mutex)

#ifdef __cplusplus
}
#endif

#endif  // End of __GLOBAL_SETTING_H

