#ifndef __HTML_IMPORT_DIALOG_H
#define __HTML_IMPORT_DIALOG_H

#include <gtk/gtk.h>
#include "html_import.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _HtmlImportDialog        HtmlImportDialog;
typedef struct _HtmlImportElementDialog HtmlImportElementDialog; 

// =================================================================

struct _HtmlImportDialog {
	GtkDialog*      self;

	GtkWidget*      entry;
	GtkWidget*      notebook;
	GtkWidget*      statusbar;

	HtmlImport*     html_import;
};

HtmlImportDialog* html_import_dialog_new (HtmlImport* hi,
                                          GtkWindow* parent);
void html_import_dialog_destroy (HtmlImportDialog* hid);
gint html_import_dialog_run (HtmlImportDialog* hid);

// =================================================================

struct _HtmlImportElementDialog {
	GtkDialog*    self;

	GtkTreeView*  address_view;
	GtkTreeView*  extension_view;

	GtkWidget*    button_all_address;
	GtkWidget*    button_none_address;
	GtkWidget*    button_all_extension;
	GtkWidget*    button_none_extension;

	HtmlImportElement* element;
};

HtmlImportElementDialog* html_import_element_dialog_new (HtmlImportElement* hie,
                                                         GtkWindow* parent);

void html_import_element_dialog_destroy (HtmlImportElementDialog* hied);


#ifdef __cplusplus
}
#endif

#endif  // End of __HTML_IMPORT_DIALOG_H
