#include "main_app.h"
#include "urlgfe.h"
#include "utility.h"

// callback for gtk_clipboard_request_text ()
static void clipboard_text_received_callback (GtkClipboard *clipboard,
                                              const gchar *text,
                                              gpointer data)
{
	MainApp* app = (MainApp*)data;
	UrlPart  urlp;

	if (text == NULL) {
		g_free (app->clipboard_text);
		app->clipboard_text = NULL;
	}
	else if (g_ascii_strcasecmp (text, STR_N2E (app->clipboard_text)) ) {
		g_free (app->clipboard_text);
		app->clipboard_text = g_strdup (text);

		url_part (&urlp, app->clipboard_text);
		if (urlp.protocol_beg && urlp.ext_beg && 
		    global_setting_find_extention (app->setting, urlp.ext_beg))
		{
			main_app_add_download_from_url (app, app->clipboard_text);
		}
	}

	app->clipboard_waiting = FALSE;
}

gboolean main_app_on_timer (MainApp* app)
{
	gchar*         clip_text = NULL;

	if (app->clipboard_monitoring && app->clipboard_waiting==FALSE) {
		app->clipboard_waiting = TRUE;
		gtk_clipboard_request_text (app->clipboard,
		                            clipboard_text_received_callback, app);
	}

	return TRUE;
}


