#include "main_app.h"
#include "dnd_data.h"

void main_app_category_dnd_received (MainApp* app,
                                     GdkDragContext* drag_context,
                                     gint x,
                                     gint y,
                                     GtkSelectionData* sd,
                                     guint info,
                                     guint time,
                                     GtkWidget* widget)
{
//	GtkTreeView* category_view = widget;
	GtkTreeView* category_view = app->window.category_view;
	GtkTreePath *path = NULL;
	GtkTreeViewDropPosition position;

	if (sd->target == gdk_atom_intern(DND_DOWNLOAD_DATA_TARGET, FALSE) && sd->data)
	{
		// drag from DownloadListView
		DownloadListView* dlv_src  = *((DownloadListView**)sd->data);
		DownloadListView* dlv_dest;

		if (gtk_tree_view_get_dest_row_at_pos (GTK_TREE_VIEW(category_view),
		                                       x, y,
		                                       &path, &position) )
		{
			GtkTreeIter       iter;

			gtk_tree_model_get_iter (GTK_TREE_MODEL(app->category_store.tree_store),
			                         &iter, path);
			gtk_tree_path_free (path);

			gtk_tree_model_get (GTK_TREE_MODEL(app->category_store.tree_store),
			                    &iter,
			                    CATEGORY_COL_DOWNLOAD_VIEW,
			                    &dlv_dest, -1);

			main_app_move_selected_download (app, dlv_src, dlv_dest);
		}
	}
}

void main_app_dnd_data_received (MainApp* app,
                                 GdkDragContext* drag_context,
                                 gint x,
                                 gint y,
                                 GtkSelectionData* data,
                                 guint info,
                                 guint time,
                                 GtkWidget* widget)
{
}

void main_app_dnd_data_get (MainApp* app,
                            GdkDragContext* drag_context,
                            GtkSelectionData* data,
                            guint info,
                            guint time,
                            GtkWidget* widget)
{
}

void main_app_dnd_init (MainApp* app)
{
	GtkTargetEntry gte = {
		DND_DOWNLOAD_DATA_TARGET,
		DND_DOWNLOAD_DATA_FLAG,
		DND_DOWNLOAD_DATA_INFO
	};

	gtk_tree_view_enable_model_drag_dest (GTK_TREE_VIEW (app->window.category_view),
	                                      &gte, 1,
	                                      GDK_ACTION_COPY | GDK_ACTION_MOVE);

	g_signal_connect_swapped (G_OBJECT (app->window.category_view),
	                          "drag-data-received",
	                          G_CALLBACK (main_app_category_dnd_received),
	                          app);
}

