/*
	proxy_setting_view.h



	Object Hierarchy :

	SettingView
	|
	`--	ProxySettingView
	    |
	    `-- DownloadSettingView
	        |
	        `--CategorySettingView



	2003  Plus Huang
 */

#ifndef __PROXY_SETTING_VIEW_H
#define __PROXY_SETTING_VIEW_H

#include "setting_view.h"

#ifdef __cplusplus
extern "C" {
#endif

#define PROXY_SETTING_VIEW(o)    ((ProxySettingView*)(o))

typedef struct _ProxySettingView      ProxySettingView;

struct _ProxySettingView {
	SettingView    setting_view;

	GtkWidget* self;

	// proxy type
	GtkWidget* radio_none;
	GtkWidget* radio_http;
	GtkWidget* radio_socks5;

	// proxy server
	GtkWidget* label_host;
	GtkWidget* label_port;
	GtkWidget* entry_host;
	GtkWidget* spin_port;

	// authentication
	GtkWidget* toggle_authentication;
	GtkWidget* label_username;
	GtkWidget* label_password;
	GtkWidget* entry_username;
	GtkWidget* entry_password;
};

void proxy_setting_view_init (ProxySettingView* view);

void proxy_setting_view_set (ProxySettingView* view,
                             ProxySetting* setting);
void proxy_setting_view_get (ProxySettingView* view,
                             ProxySetting* setting);

void proxy_setting_view_set_multiple (ProxySettingView *view,
                                      gboolean multiple);

#ifdef __cplusplus
}
#endif

#endif // End of __PROXY_SETTING_VIEW_H

