#include "selection_store.h"

GtkListStore* selection_store_new ()
{
	return gtk_list_store_new (SELECTION_STORE_N_COLUMNS,
	                           G_TYPE_BOOLEAN,
	                           G_TYPE_STRING,
	                           G_TYPE_INT);
}

void selection_store_set_selection_all (GtkListStore* ls,
                                        gboolean selection)
{
	GtkTreeIter iter;
	gboolean valid;

	valid = gtk_tree_model_get_iter_first(GTK_TREE_MODEL(ls), &iter);
	while(valid) {
		gtk_list_store_set (ls, &iter,
		                    SELECTION_STORE_SELECTED, selection,
		                    SELECTION_STORE_COUNT, 0,
		                    -1);
		valid = gtk_tree_model_iter_next (GTK_TREE_MODEL(ls), &iter);
	}
}

gboolean selection_store_get_first_selected (GtkListStore* ls,
                                             GtkTreeIter* iter,
                                             gchar** return_str)
{
	gboolean valid, selected;
	gchar*   string;

	valid = gtk_tree_model_get_iter_first (GTK_TREE_MODEL(ls), iter);
	while (valid) {
		gtk_tree_model_get (GTK_TREE_MODEL(ls), iter,
		                    SELECTION_STORE_SELECTED, &selected,
		                    SELECTION_STORE_STRING, &string,
		                    -1);
		if (selected) {
			if (return_str)
				*return_str = string;
			return TRUE;
		}
		valid = gtk_tree_model_iter_next (GTK_TREE_MODEL(ls), iter);
	}
	return FALSE;
}

gboolean selection_store_get_next_selected (GtkListStore* ls,
                                            GtkTreeIter* iter,
                                            gchar** return_str)
{
	gboolean valid, selected;
	gchar*   string;

	valid = gtk_tree_model_iter_next (GTK_TREE_MODEL(ls), iter);
	while (valid) {
		gtk_tree_model_get (GTK_TREE_MODEL(ls), iter,
		                    SELECTION_STORE_SELECTED, &selected,
		                    SELECTION_STORE_STRING, &string,
		                    -1);
		if (selected) {
			if (return_str)
				*return_str = string;
			return TRUE;
		}
		valid = gtk_tree_model_iter_next (GTK_TREE_MODEL(ls), iter);
	}
	return FALSE;
}

