//  urlgfe.h
//
//    Internal definitions for UrlGfe
//
//

#ifndef __URLGFE_H
#define __URLGFE_H

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#ifdef _WIN32
#define ENABLE_NLS      1
#define GETTEXT_PACKAGE "urlgfe"
#endif

#include <glib.h>

#ifdef ENABLE_NLS
#  include <libintl.h>
#  define _(x) gettext(x)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define N_(String) (String)
#  define _(x) (x)
#  define ngettext(Singular, Plural, Number) ((Number == 1) ? (Singular) : (Plural))
#endif

//	if str==NULL, return empty string ""
//  NULL string to empty string
#define STR_N2E(str)    ( (str) ? str : "" )

void  urlgfe_init (int argc, char *argv[]);
const gchar* urlgfe_get_prog_dir ();
const gchar* urlgfe_get_conf_dir ();
const gchar* urlgfe_get_image_dir ();
const gchar* urlgfe_get_locale_dir ();
const gchar* urlgfe_get_data_filename ();
const gchar* urlgfe_get_conf_filename ();

void urlgfe_disable_console_output ();

#endif  // End of __URLGFE_H

